#pragma once

#include "ctexport.h"

#define	SCSI_TUR		0x00		/* Test unit ready */
#define	SCSI_REWIND		0x01		/* Rewind */
#define	SCSI_SPACE		0x11		/* Positioning functions */
#define SCSI_LOADUNLOAD 0x1b
#define SCSI_ERASE 0x19
#define SCSI_READ_BLOCK_LIMITS 0x05
#define SCSI_READ 0x08
#define SCSI_WRITE 0x0a

#define	SCSI_TAPE_WP		0x80		/* tape write protect */

long ct_open (device_info *info, ulong flags);
long ct_close (device_info *info);
long ct_control (device_info *info, ulong op, void *data);
long ct_read (device_info *info, void *buffer, ulong numBytes, ulong position);
long ct_write (device_info *info, void *buffer, ulong numBytes, ulong position);

long cam_action_sync (CCB_HEADER *ccb);
long cam_fmt_ccb_header (CCB_HEADER *ccb, u_char func_code, u_char path_id, u_char target_id, u_char target_lun, U32 flags);
long cam_do_scsi_noio (u_char path_id, u_char target_id, u_char target_lun, struct cdb6 *cdb, u_char *cam_status, u_char *scsi_status);
long cam_do_scsi_output (u_char path_id, u_char target_id, u_char target_lun, struct cdb6 *cdb, u_char *buffer, u_long buflen, u_char *cam_status, u_char *scsi_status);
long cam_do_scsi_input (u_char path_id, u_char target_id, u_char target_lun, struct cdb6 *cdb, u_char *buffer, u_long buflen, u_char *cam_status, u_char *scsi_status);
void outputautosensebuffer (struct sense_data *sensebuffer);

long cam_tur (u_char path_id, u_char target_id, u_char target_lun, u_char *cam_status, u_char *scsi_status);
long cam_rewind (u_char path_id, u_char target_id, u_char target_lun, u_char *cam_status, u_char *scsi_status);
long cam_loadunload (u_char path_id, u_char target_id, u_char target_lun, bool load, u_char *cam_status, u_char *scsi_status);
long cam_erase (u_char path_id, u_char target_id, u_char target_lun, bool full, u_char *cam_status, u_char *scsi_status);
long cam_read (u_char path_id, u_char target_id, u_char target_lun, u_char *buffer, u_long buflen, u_char *cam_status, u_char *scsi_status);
long cam_write (u_char path_id, u_char target_id, u_char target_lun, u_char *buffer, u_long buflen, u_char *cam_status, u_char *scsi_status);

void ddprint (const char *string);
void ddprintlong (ulong x);
void ddprinthexlong (ulong x);
void ddclear ();

struct cdb6
{
	u_char opcode;
	u_char lun;
	u_char byte3,byte4;
	u_char length;
	u_char control;
};

struct driverdata
{
	u_char path_id;
	u_char target_id;
	u_char target_lun;

	ulong minblksize;
	ulong maxblksize;
};

struct sense_data
{
	u_char error_code;
	u_char segment;
	u_char filemarkEomIliReservedSensekey;
	u_char info0,info1;
	u_char add_sense_length;
};

