#include <Drivers.h>
#include <KernelExport.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include "../ct/ctexport.h"

int main (int argc, char **argv)
{
	int result;
	
	if (argc!=3)
	{
		printf ("wrong number of arguments\n");
		printf ("usage: mt /dev/scsi_tape_xxx REWIND|[SHORT]ERASE|FULLERASE\n");
		return 1;
	}
	
	int fd=open (argv[1],O_RDWR);

	if (fd<0)
	{
		printf ("could not open device.\n");
		
		return 1;
	}
	
	if (!strcasecmp("REWIND",argv[2]))
	{	
		printf ("rewinding tape\n");

		result=ioctl (fd,TAPE_REWIND);
	
		if (result<0)
			printf ("rewinding failed.\n");
	}
	else if ((!strcasecmp("SHORTERASE",argv[2]))||(!strcasecmp("ERASE",argv[2])))
	{
		printf ("short erasing tape\n");

		char full=0;		
		result=ioctl (fd,TAPE_ERASE,&full);
		
		if (result<0)
			printf ("erase failed.\n");
	}
	else if (!strcasecmp("FULLERASE",argv[2]))
	{
		printf ("full erasing tape\n");

		char full=1;		
		result=ioctl (fd,TAPE_ERASE,&full);
		
		if (result<0)
			printf ("erase failed.\n");
	}
	else
		printf ("unknown command.\n");

	result=close (fd);

	if (result<0)
	{
		printf ("could not close device.\n");
		
		return 1;
	}

	return 0;
}
